function [Hakt,H,h]=Transfer
%errechnet und plottet -Funktion von xs,ys,zs nach xe,ye,ze in Raum Lx,Ly,Lz
%und transformiert die Impulsanwort h. 
global Lx Ly Lz xs ys zs xe ye ze ax0 axL ay0 ayL az0 azL;%wurde in Raum_test2s definiert
global ax0_ axL_ ay0_ ayL_ az0_ azL_;
global fs c fftsize fschroeder f; %braucht man spter
global radio_hp radio_res radio_dir %Status der Radiobuttons
global xea xsa yea ysa zea zsa pmax %braucht man spter fr Direktschall
global fg %braucht man spter fr Hochpass
global kx ky kz %fr die Darstellung der Resonanzen in resomatrix
fres=[];
fs=44100;%Samplingfrequenz
fftsize=2^16;%Grad der FFT-Transformation
lmax=max([Lx Ly Lz]);%maximale Raumabmessung
xsa=(xs*Lx)/100; ysa=(ys*Ly)/100; zsa=(zs*Lz)/100;%abs.Senderposition, vorher war ja in %
xea=(xe*Lx)/100; yea=(ye*Ly)/100; zea=(ze*Lz)/100;%abs.Empfnger
c=343.4;%Schallgeschw
df=fs/2/fftsize;%hier kommt der Faktor 2 her!!
dt=1/fs;
Tl=1/df;%Zeitfensterlnge
t=0:dt:Tl;%Zeitvektor
f=0:df:(fftsize-1)*df;%Frequenzvektor
f(1)=eps;%erster Wert soll nicht Null sein, damit es kein "error- divide bei zero" gibt
V = Lx*Ly*Lz;%Volumen 
S = 2*(Lx*Ly+Ly*Lz+Lx*Lz);%Oberflche
A = -(Ly*Lz*log(1-ax0) + Ly*Lz*log(1-axL) + Lx*Lz*log(1-ay0) + Lx*Lz*log(1-ayL) + Lx*Ly*log(1-az0) + Lx*Ly*log(1-azL));%quivalente Absorptionsflche
T = 0.163*V./A;%Nachhallzeit nach Sabine
fschroeder = 2000*(T./V)^.5;%Schrderfrequenz
N = 4/3*pi*V*(fschroeder./c)^3 + 4/pi*S*(fschroeder./c)^2;%Modenzahl bis Schrderfrequenz
k = ceil(N^(1/3));%bis Modus(k/k/k)
kx=2*ceil(2*fschroeder*Lx/c);%2*hchste Resonanz bis Schrderfrequenz in x-Richtung
ky=2*ceil(2*fschroeder*Ly/c);%2*hchste Resonanz bis Schrderfrequenz in y-Richtung
kz=2*ceil(2*fschroeder*Lz/c);%2*hchste Resonanz bis Schrderfrequenz in z-Richtung
ax0_=-log(1-ax0);%genaue Formel fr Absorbtionsgrad, z.B. nach Cremer
axL_=-log(1-axL);
ay0_=-log(1-ay0);
ayL_=-log(1-ayL);
az0_=-log(1-az0);
azL_=-log(1-azL);
H=zeros(1,length(f));%Auf diesem Vektor werden jetzt fr alle Resonanzen die Werte aufsummiert
for l=0:kx
    for m=0:ky
        for n=0:kz
            if l+m+n>0
                fres=fxyz(Lx,Ly,Lz,l,m,n);%Resonanzfrequenz
                delta=deltaxyz(l,m,n,ax0_,axL_,ay0_,ayL_,az0_,azL_,Lx,Ly,Lz,fres);%Dmpfung nach Cremer
                Acos=Almn(l,m,n,xsa,ysa,zsa,xea,yea,zea,Lx,Ly,Lz);
                if fres<2*fschroeder %nur bis2xSchrderfrequenz
                    H=H+Acos*pfd(f,fres,delta);
                end
            end
        end
    end
end

%Berechnung des maximal mglichen Werts der -Fkt:
%Dazu Bestimmung des kleinsmglichen Wertes fr Delta:
%eine der drei Axialmoden muss es sein:
deltaK00=c*(ax0_+axL_)/(4*Lx);
delta0K0=c*(ay0_+ayL_)/(4*Ly);
delta00K=c*(az0_+azL_)/(4*Lz);
deltas=[deltaK00 delta0K0 delta00K];
deltamin=min(deltas);
pmax=1/2/deltamin;

%H ist bertragungsfunktion fr "nur Resonanzen". Nun wird Hakt berechnet,
%die bertragungsfunktion je nach Preset, nur Res., Hochpass oder
%+Direktschall.
fg=fxyz(Lx,Ly,Lz,kx,ky,kz)/2; % 1Okt. tiefer als oberste Resonanz = Grenzfrequenz fr den Hochpass, braucht man spter
if radio_hp == 1%wenn im GUI Raum_test2s der radiobutton "Hochpass" gewhlt ist
    hpamp=max(abs(H))/10;%Hochpassamplitude: 20 dB unter Maximum
    hp=hpamp./(1+j*fg^4./f.^4);%Hochpass fr glatten Frequenzgang oberhalb fg
    Hakt=H+hp;%dazuaddieren
elseif radio_dir == 1%wenn im GUI Raum_stereod der radiobutton "Direktschall addieren" gewhlt ist
    bezugsr=0.1; %Bezugspunkt (Entfernung v.d. Quelle), whlbar
    %pmax=pmax;
    dirmax=pmax; %Schalldruck in Entfernung bezugsr von der Quelle, whlbar
    if ((xsa-xea)^2+(ysa-yea)^2+(zsa-zea)^2)^.5 <= bezugsr
        pdir=dirmax; %damit der Schalldruck nicht unendlich gro werden kann
    else pdir=bezugsr*dirmax/((xsa-xea)^2+(ysa-yea)^2+(zsa-zea)^2)^.5;%Direktschall=Pegel*1/r;
    end
    Hakt=H+pdir;%Direktschall dazuaddieren -> "aktuelle" -Fkt
else Hakt=H;
end

Hakt=exp(-j*1.5*f).*Hakt;%Zeitverschiebung damit Einschwingen erhalten bleibt
Transferplot(Hakt)
%inverse FFT
h=real(ifft(Hakt,2*fftsize));% Faktor 2 wichtig sonst stimmen die Frequenzen nicht!!!
h=h/max(abs((h)));%Impulsantwort auf 1 normiert


